package com.oreilly.jent.ejb.messageDriven;

/**
 * In general, you may use the code in this book in your programs and 
 * documentation. You do not need to contact us for permission unless 
 * you're reproducing a significant portion of the code. For example, 
 * writing a program that uses several chunks of code from this book does 
 * not require permission. Selling or distributing a CD-ROM of examples 
 * from O'Reilly books does require permission. Answering a question by 
 * citing this book and quoting example code does not require permission. 
 * Incorporating a significant amount of example code from this book into 
 * your product's documentation does require permission.
 * 
 * We appreciate, but do not require, attribution. An attribution usually 
 * includes the title, author, publisher, and ISBN. For example: 
 * 
 *   "Java Enterprise in a Nutshell, Third Edition, 
 *    by Jim Farley and William Crawford 
 *    with Prakash Malani, John G. Norman, and Justin Gehtland. 
 *    Copyright 2006 O'Reilly Media, Inc., 0-596-10142-2."
 *  
 *  If you feel your use of code examples falls outside fair use or the 
 *  permission given above, feel free to contact us at 
 *  permissions@oreilly.com.
 */

import javax.jms.MapMessage;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.jms.Session;
import javax.naming.Context;
import javax.naming.InitialContext;

public class ProfileJMSClient {
    public static void main(String args[]) {
        String name = null;
        if (args.length > 0) {
            name = args[0];
        }
        
        // If there are two more arguments, then continue
        if (args.length > 2) {
            try {
                // Get a JNDI context from our EJB server, using the 
                // properties in jndi.properties 
                Context context = new InitialContext();
                
                // Lookup the JMS queue connection factory
                QueueConnectionFactory qFactory =
                    (QueueConnectionFactory) context.lookup("jms/jent-EJB-connFactory");
                QueueConnection qConn = qFactory.createQueueConnection();
                qConn.start();
                
                // Lookup the JMS message queue for the message-driven bean
                Queue profQueue = (Queue) context.lookup("jms/ProfileProxyQueue");
                
                // Create a session with the JMS server
                QueueSession qSession =
                    qConn.createQueueSession(false, Session.AUTO_ACKNOWLEDGE);
                
                // Create a sender
                QueueSender sender = qSession.createSender(profQueue);
                
                // Create a MapMessage
                MapMessage msg = qSession.createMapMessage();
                
                // Set the name for the target profile
                msg.setString("OWNER", name);
                
                // Set the entry value given on the command-line
                msg.setString(args[1], args[2]);
                
                // Send the message
                sender.send(msg);
            }
            catch (Exception e) {
                System.out.println("Error while creating/using message-driven bean.");
                e.printStackTrace();
            }
        }
        else {
            System.out.println("Invalid command-line args.");
        }
    }
}
